<?php
/**
 * @package     BreezingForms
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// TODO: uninstall routine

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

function bf_constantcontact_startsWith($haystack, $needle) {
    // search backwards starting from haystack length characters from the end
    return $needle === "" || strrpos($haystack, $needle, -strlen($haystack)) !== FALSE;
}

require_once JPATH_SITE . '/plugins/breezingforms_addons/constantcontact/breezingforms_addons_constantcontact_libraries/src/Ctct/autoload.php';
require_once JPATH_SITE . '/plugins/breezingforms_addons/constantcontact/breezingforms_addons_constantcontact_libraries/vendor/autoload.php';
        
use Ctct\ConstantContact;
use Ctct\Components\Contacts\Contact;
use Ctct\Exceptions\CtctException;

if(!defined('DS')){
    define('DS', DIRECTORY_SEPARATOR);
}

//require_once JPATH_SITE . DS . 'plugins' . DS . 'breezingforms_addons' . DS . 'constantcontact' . DS . 'breezingforms_addons_constantcontact_libraries' . DS . '';
 
jimport( 'joomla.plugin.plugin' );
jimport('joomla.version');
               
class plgBreezingforms_addonsConstantcontact extends JPlugin
{
    private $fields = array();
    
    function __construct( &$subject, $params )
    {
        parent::__construct($subject, $params);
    
        $this->fields['email_address'] = ''; // email addresses
        $this->fields['prefix_name'] = '';
        $this->fields['first_name'] = '';
        $this->fields['last_name'] = '';
        $this->fields['company_name'] = '';
        $this->fields['job_title'] = '';
        
        $this->fields['work_phone'] = '';
        $this->fields['home_phone'] = '';
        $this->fields['cell_phone'] = '';
        $this->fields['fax'] = '';
        // notes don't work yet
        //$this->fields['notes'] = '';
        
        // replace home_address_ / business_address_ by nothing and put both home and business into an array
        // addresses = array([],[])
        
        $this->fields['home_address_line1'] = '';
        $this->fields['home_address_line2'] = '';
        $this->fields['home_address_line3'] = '';
        $this->fields['home_address_city'] = '';
        $this->fields['home_address_address_type'] = '';
        $this->fields['home_address_state_code'] = '';
        $this->fields['home_address_state'] = '';
        $this->fields['home_address_country_code'] = '';
        $this->fields['home_address_postal_code'] = '';
        $this->fields['home_address_sub_postal_code'] = '';
        
        $this->fields['business_address_line1'] = '';
        $this->fields['business_address_line2'] = '';
        $this->fields['business_address_line3'] = '';
        $this->fields['business_address_city'] = '';
        $this->fields['business_address_address_type'] = '';
        $this->fields['business_address_state_code'] = '';
        $this->fields['business_address_state'] = '';
        $this->fields['business_address_country_code'] = '';
        $this->fields['business_address_postal_code'] = '';
        $this->fields['business_address_sub_postal_code'] = '';
        
        //$this->fields['custom_fields'] = array();
        
        $lang = JFactory::getLanguage();
        $lang->load('plg_breezingforms_addons_constantcontact', JPATH_ADMINISTRATOR);
        
        $db = JFactory::getDBO();
        
        $tables = $db->getTableList();
        
        if( !in_array( $db->getPrefix().'breezingforms_addons_constantcontact', $tables ) ){
            
            
            $db->setQuery("CREATE TABLE `#__breezingforms_addons_constantcontact` (
            `id` int(11) NOT NULL,
            `form_id` int(11) NOT NULL DEFAULT '0',
            `apikey` varchar(255) NOT NULL DEFAULT '',
            `enabled` tinyint(1) NOT NULL DEFAULT '0',
            `access_token` varchar(255) NOT NULL DEFAULT '',
            `options` text NOT NULL
          ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8");
            
            $db->execute();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_constantcontact`
            ADD PRIMARY KEY (`id`),
            ADD UNIQUE KEY `form_id_2` (`form_id`),
            ADD KEY `access_token` (`access_token`),
            ADD KEY `apikey` (`apikey`),
            ADD KEY `apikey_2` (`apikey`,`access_token`)");
            
            $db->execute();
            
            $db->setQuery("ALTER TABLE `#__breezingforms_addons_constantcontact`
            MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=13");
            
            $db->execute();

        }
        
        jimport('joomla.filesystem.file');
        
    }
    
    function onPropertiesDisplay($form_id, $tabs){
        
        if(!$form_id) return '';
        
        $lists = array();
        $error = '';
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select `title`,`name`,`id` From #__facileforms_elements Where form = " . intval($form_id) . " And `title` Not In ('bfFakeTitle','bfFakeTitle2','bfFakeTitle3','bfFakeTitle4','bfFakeTitle5') And `type` Not In ('','UNKNOWN','File Upload') Order By ordering");
        $breezingforms_fields = $db->loadObjectList();
        
        $db->setQuery("Select * From #__breezingforms_addons_constantcontact Where form_id = " . intval($form_id));
        $cc = $db->loadObject();
        
        if( $cc === null || $cc->apikey == '' || $cc->access_token == '' ){
            
            $cc = new stdClass();
            $cc->id = 0;
            $cc->form_id = 0;
            $cc->apikey = '';
            $cc->access_token = '';
            $cc->enabled = 0;
            $cc->options = json_decode('{"lists":[], "fields":[], "optout":0, "optout_fieldvalue":"", "custom_fields" : [], "error_emails" : []}');
            
        }else{
            
            $cc->options = json_decode($cc->options);
            
            $_cc = new \Ctct\ConstantContact($cc->apikey);
        
            try{
                
                $info = $_cc->accountService->getAccountInfo($cc->access_token);
                $lists = $_cc->listService->getLists($cc->access_token);
                
                
            } catch (CtctException $ex) {
                foreach ($ex->getErrors() as $error) {
                    print_r($error);
                }
            }
        }
        
        $auth_url = 'https://developer.constantcontact.com/api-keys.html';
        
        ob_start();
        require_once JPATH_SITE . DS . 'plugins' . DS . 'breezingforms_addons' . DS . 'constantcontact' . DS . 'breezingforms_addons_constantcontact_tmpl' . DS . 'properties.php';
        $c = ob_get_contents();
        ob_end_clean();
        return $c;
    }
    
    function onPropertiesSave($form_id){
        
        if(!$form_id) return '';
        
        $apiKey = '';
        $accessToken = '';
        $reset_accessToken = false;
        
        if(isset($_POST['constantcontact_apikey']) && $_POST['constantcontact_apikey'] != ''){
            
            $apiKey = $_POST['constantcontact_apikey'];
        }
        
        if(isset($_POST['constantcontact_access_token']) && $_POST['constantcontact_access_token'] != ''){
            
            $accessToken = $_POST['constantcontact_access_token'];
        }
        
        if(isset($_POST['constantcontact_reset'])){
            $reset_accessToken = true;
            $accessToken = '';
            $apiKey = '';
        }
        
        $error_emails = isset($_POST['constantcontact_error_emails']) && $_POST['constantcontact_error_emails'] != '' ? $_POST['constantcontact_error_emails'] : '';
        $error_emails = str_replace("\r", "", $error_emails);
        $error_emails = explode("\n", $error_emails);
        
        $optout = isset($_POST['constantcontact_optout']) && is_numeric($_POST['constantcontact_optout']) && intval($_POST['constantcontact_optout']) > 0  ? intval($_POST['constantcontact_optout']) : 0;
        $optout_fieldvalue = isset($_POST['constantcontact_optout_fieldvalue']) && $_POST['constantcontact_optout_fieldvalue'] != '' ? $_POST['constantcontact_optout_fieldvalue'] : '';
        
        $fields = isset($_POST['constanctcontact_fields']) && is_array($_POST['constanctcontact_fields']) ? $_POST['constanctcontact_fields'] : array();
        $lists = isset($_POST['constantcontact_lists']) && is_array($_POST['constantcontact_lists']) ? $_POST['constantcontact_lists'] : array();
        $custom_fields = isset($_POST['constantcontact_custom_fields']) && is_array($_POST['constantcontact_custom_fields']) ? $_POST['constantcontact_custom_fields'] : array();
        
        $options = '{"lists":'.json_encode($lists).', "fields":'.json_encode($fields).', "optout":'.json_encode($optout).', "optout_fieldvalue":'.json_encode($optout_fieldvalue).', "custom_fields" : '.json_encode($custom_fields).', "error_emails": '.json_encode($error_emails).'}';
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select form_id From #__breezingforms_addons_constantcontact Where form_id = " . intval($form_id));
        $exists = $db->loadResult();
        
        if(!$exists){
            
            $db->setQuery("Insert Into #__breezingforms_addons_constantcontact (options, form_id, apikey, access_token) Values (".$db->quote($options).",".$db->quote(intval($form_id)).",".$db->quote(JRequest::getVar('constantcontact_apikey','')).",".$db->quote(JRequest::getVar('constantcontact_access_token','')).")");
            $db->execute();
            
        } else {
            
            $db->setQuery("Update #__breezingforms_addons_constantcontact Set
                
                options = ".$db->quote($options).",
                enabled = ".$db->quote(!$reset_accessToken ? JRequest::getInt('constantcontact_enabled',0) : 0)."
                ".($apiKey || $reset_accessToken ? ",`apikey` = " . $db->quote($apiKey) : '')."
                ".($accessToken || $reset_accessToken ? ",`access_token` = " . $db->quote($accessToken) : '')."
                Where
                    form_id = ".intval($form_id)."
            ");
            
            $db->execute();
            
        }
    }
    
    function onPropertiesExecute($processor){
        
        if(!$processor->form) return;
        
        $db = JFactory::getDBO();
        
        $db->setQuery("Select * From #__breezingforms_addons_constantcontact Where form_id = " . intval($processor->form));
        $cc = $db->loadObject();
        
        if( $cc === null ){
            $cc = new stdClass();
            $cc->id = 0;
            $cc->form_id = 0;
            $cc->head_data = 0;
            $cc->apikey = '';
            $cc->access_token = '';
            $cc->enabled = 0;
            $cc->options = json_decode('{"lists":[], "fields":[], "optout":0, "optout_fieldvalue":"", "custom_fields" : [], "error_emails" : []}');
        } else {
            
            $cc->options = json_decode($cc->options);
        }
        
        if( $cc->enabled == 1 ){
            
            try {
                
                $fields = array();
                $out_fields = array();
                $title_fields = array();
                $value_fields = array();
                
                foreach($cc->options->fields As $field){
                    
                    $keyval = explode('::', $field);
                    
                    if(count($keyval) == 2){
                        $fields[$keyval[0]] = $keyval[1];
                    }
                }
                
                foreach($processor->maildata As $data){
                    if( isset( $fields[$data[_FF_DATA_ID]] ) ){
                        $out_fields[$fields[$data[_FF_DATA_ID]]] = $data[_FF_DATA_VALUE];
                    }
                    $title_fields[$data[_FF_DATA_ID]] = $data[_FF_DATA_TITLE];
                    $value_fields[$data[_FF_DATA_ID]] = $data[_FF_DATA_VALUE];
                }
                
                
                if(!isset($out_fields['email_address'])){
                    return;
                }
                
                if(count($cc->options->lists) == 0){
                    return;
                }
                
                $home = array();
                $business = array();
                $final = array();
                
                // creating the final object to hand over to CC, leaving out email as it will be added separately
                foreach($out_fields As $cc_field_key => $cc_value){
                    
                    if(bf_constantcontact_startsWith($cc_field_key, 'home_address_')){
                        $home_key = explode('home_address_', $cc_field_key);
                        $home[$home_key[1]] = $cc_value;
                    }
                    else
                    if(bf_constantcontact_startsWith($cc_field_key, 'business_address_')){
                        $business_key = explode('business_address_', $cc_field_key);
                        $business[$business_key[1]] = $cc_value;
                    }else
                    if($cc_field_key == 'email_address'){
                        // leave out
                    }else
                    if($cc_field_key == 'notes'){
                        // notes don't work yet
                        //$note = new \Ctct\Components\Contacts\Note();
                        //$note->note = $cc_value;
                        //$final[$cc_field_key] = array($note);
                    }else{
                        $final[$cc_field_key] = $cc_value;
                    }
                }
                
                if( count($home) > 0 ){
                    $home['address_type'] = 'PERSONAL';
                    $final['addresses'][] = $home;
                }
                
                if( count($business) > 0 ){
                    $business['address_type'] = 'BUSINESS';
                    $final['addresses'][] = $business;
                }
                
                $_cc = new \Ctct\ConstantContact($cc->apikey);
                
                // check to see if a contact with the email address already exists in the account
                $response = $_cc->contactService->getContacts($cc->access_token, array("email" => $out_fields['email_address']));
                
                // create a new contact if one does not exist
                if (empty($response->results)) {
                    
                    $contact = new \Ctct\Components\Contacts\Contact();
                    $contact->addEmail($out_fields['email_address']);
                    
                    foreach($cc->options->lists As $list){
                        $contact->addList($list);
                    }
                    
                    foreach($final As $final_key => $final_value){
                        $contact->$final_key = $final_value;
                    }
                    
                    $i = 1;
                    foreach( $cc->options->custom_fields As $custom_field ){

                        if( $i < 16 ){

                            $customField = new \Ctct\Components\Contacts\CustomField();
                            $customField->name = "CustomField".$i;
                            $customField->value = '[' . $title_fields[$custom_field] . '] ' . $value_fields[$custom_field];
                            $contact->addCustomField($customField);
                        }

                        $i++;
                    }
                    
                    $returnContact = $_cc->contactService->addContact($cc->access_token, $contact);
                
                // update the existing contact if address already existed
                } else {
                    
                    $contact = $response->results[0];
                    if ($contact instanceof \Ctct\Components\Contacts\Contact) {
                        
                        if(isset($value_fields[$cc->options->optout]) && $cc->options->optout && $value_fields[$cc->options->optout] == $cc->options->optout_fieldvalue){
                            
                            // seems the only way to get removed from everywhere
                            $contact->lists = array();
                            
                        } else {
                        
                            foreach($cc->options->lists As $list){
                                $contact->addList($list);
                            }

                            foreach($final As $final_key => $final_value){
                                $contact->$final_key = $final_value;
                            }

                            $i = 1;
                            foreach( $cc->options->custom_fields As $custom_field ){

                                if( $i < 16 ){

                                    $customField = new \Ctct\Components\Contacts\CustomField();
                                    $customField->name = "CustomField".$i;
                                    $customField->value = '[' . $title_fields[$custom_field] . '] ' . $value_fields[$custom_field];
                                    $contact->addCustomField($customField);
                                }

                                $i++;
                            }
                        
                        }
                        
                        $returnContact = $_cc->contactService->updateContact($cc->access_token, $contact);
                        
                    } else {
                        // we don't care, show must go on
                    }
                }
                
            } catch (CtctException $ex) {
                
                foreach( $cc->options->error_emails As $error_email ){
                    
                    $body = 'Error with adding a user to constant contact. Form ID (see "scriptId" in Form Manager): ' . $processor->form."\n\n";
                    $body .= 'Message: '.$ex->getMessage()."\n\n";
                    $body .= 'Trace: ' . "\n" . $ex->getTraceAsString();
                    
                    JFactory::getMailer()->sendMail(JFactory::getConfig()->get('email'), JFactory::getConfig()->get('fromname'), $error_email, 'BreezingForms ConstantContact Error', $body);
                    
                }
            }
        }
    }
}
